/*+------------------------------------------------------------------+
 | FileName: i_DCG_Camarilla.mq4
 | Author: Copyright  2005, Fermin Da Costa Gomez
 | Version : 01 (Inital code)
 | Modified by J.Whitnell 4/2006  whitnell@gmail.com
 |   Added StartHour variable.  Changed calculation of P.  Removed H-2
 |   added H-5.  Added labels to all outputs
 | 
 +------------------------------------------------------------------+*/
#property copyright "Copyright  2005, Fermin Da Costa Gomez"
#property link      "http://forex.viahetweb.nl"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Aqua
#property indicator_color2 DarkGoldenrod
#property indicator_color3 DarkGoldenrod
#property indicator_color4 Yellow
#property indicator_color5 Yellow
#property indicator_color6 LawnGreen
#property indicator_color7 LawnGreen

extern int StartHour=14;

//---- input parameters

//---- buffers
double PBuffer[];
double H4Buffer[];
double H3Buffer[];
double H5Buffer[];
double L5Buffer[];
double L3Buffer[];
double L4Buffer[];
string Pivot="Pivot",sL5="L5", sH5="H5";
string sL3="L3", sH3="H3", sL4="L4", sH4="H4";
int fontsize=10;
double P, L5, L3, L4, H3, H4, H5;
double LastHigh,LastLow,x;

double D1=0.091667;
double D2=0.183333;
double D3=0.2750;
double D4=0.55;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("Pivot");
   ObjectDelete("L5");
   ObjectDelete("H5");
   ObjectDelete("L3");
   ObjectDelete("H3");
   ObjectDelete("L4");
   ObjectDelete("H4");   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;

   //GMT = GMTHours * 60 * 60;
   
   //Print( "GMTHours=", GMTHours, "  GMT=", GMT );
   
//---- indicator line
   SetIndexStyle(0,DRAW_LINE, 0, 2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(0, PBuffer);
   SetIndexBuffer(1, L5Buffer);
   SetIndexBuffer(2, H5Buffer);
   SetIndexBuffer(3, L3Buffer);
   SetIndexBuffer(4, H3Buffer);
   SetIndexBuffer(5, L4Buffer);
   SetIndexBuffer(6, H4Buffer);
   SetIndexLabel( 0, "Pivot" );
   SetIndexLabel( 1, "L-5" );
   SetIndexLabel( 2, "H-5" );
   SetIndexLabel( 3, "L-3" );
   SetIndexLabel( 4, "H-3" );
   SetIndexLabel( 5, "L-4" );
   SetIndexLabel( 6, "H-4" );

   x=Period();
   if (x>240) return(-1);
   ObjectCreate("L5", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L5", "         L5",fontsize,"Arial", White);
   ObjectCreate("H5", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H5", "         H5",fontsize,"Arial", White);
   ObjectCreate("L3", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L3", "Buy Rev L-3",fontsize,"Arial", White);
   ObjectCreate("H3", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H3", "Sell Rev H-3",fontsize,"Arial", White);
   ObjectCreate("L4", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("L4", "Sell B/O  L-4",fontsize,"Arial", White);
   ObjectCreate("H4", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("H4", "Buy B/O  H-4",fontsize,"Arial", White);
   ObjectCreate("Pivot", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("Pivot", "P",fontsize,"Arial", White);

//---- name for DataWindow and indicator subwindow label
   short_name="Camarilla levels";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int    counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
//   if(counted_bars>0) counted_bars--;
   limit=(Bars-counted_bars)-1;
   limit = Bars-1;

if ( LastHigh == 0 ) {
   LastHigh = Open[limit];
   LastLow = Open[limit];
}

for (i=limit; i>=0;i--)
{ 

if (High[i+1]>LastHigh) LastHigh=High[i+1];
if (Low[i+1]<LastLow) LastLow=Low[i+1];

int day = TimeDayOfWeek( Time[i] );
int hour = TimeHour( Time[i] );
int minute = TimeMinute( Time[i] );
//if ( i < 20 ) Print( i, " day=", day, " hour=", hour, " min=",minute );
if (day != 0 && day != 6 && hour == StartHour && minute == 0)
   { 
   P=(LastHigh+LastLow+Close[i+1])/3;
   if ( LastLow > 0 )
      H5 = (LastHigh/LastLow)*Close[i+1];
   else
      H5 = 0;
   //H2 = (LastHigh - LastLow)*D2 +Close[i+1];
   //L2 = Close[i+1] - (LastHigh - LastLow)*D2;
   H3 = (LastHigh - LastLow)*D3 +Close[i+1];
   L3 = Close[i+1] - (LastHigh - LastLow)*D3;
   H4 = (LastHigh-LastLow)*D4 + Close[i+1];
   L4 = Close[i+1] - (LastHigh-LastLow)*D4; 
   L5 = Close[i+1] - (H5 - Close[i+1]);
   P = (H3 + L3) / 2;
   
   LastLow=Open[i];
   LastHigh=Open[i];


   }
   
    PBuffer[i]=P;
    L5Buffer[i]=L5;
    L3Buffer[i]=L3;
    L4Buffer[i]=L4;
    H5Buffer[i]=H5;
    H3Buffer[i]=H3;
    H4Buffer[i]=H4;

}

   ObjectMove("Pivot", 0, Time[0],P);
   ObjectSetText( "Pivot", "        P="+DoubleToStr(PBuffer[0],Digits), 10, "Arial", White );
   ObjectMove("L5", 0, Time[0], L5);
   ObjectSetText( "L5", "        L5="+DoubleToStr(L5Buffer[0],Digits), 10, "Arial", White );
   ObjectMove("H5", 0, Time[0], H5);
   ObjectSetText( "H5", "        H5="+DoubleToStr(H5Buffer[0],Digits), 10, "Arial", White );
   ObjectMove("L3", 0, Time[0], L3);
   ObjectSetText( "L3", "        L3="+DoubleToStr(L3Buffer[0],Digits), 10, "Arial", White );
   ObjectMove("H3", 0, Time[0], H3);
   ObjectSetText( "H3", "        H3="+DoubleToStr(H3Buffer[0],Digits), 10, "Arial", White );
   ObjectMove("L4", 0, Time[0], L4);
   ObjectSetText( "L4", "        L4="+DoubleToStr(L4Buffer[0],Digits), 10, "Arial", White );
   ObjectMove("H4", 0, Time[0], H4);
   ObjectSetText( "H4", "        H4="+DoubleToStr(H4Buffer[0],Digits), 10, "Arial", White );

//----
   return(0);
  }
//+------------------------------------------------------------------+